/*
 *		Rendering	Program		Ver 2
 *
 *				1989.12.17
 *				CopyRight	T.Kobayashi
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#if !defined(DJ) && !defined(UNIX)
	#include <conio.h>
#endif
#if defined(MSC)
	#include <sys/types.h>
#endif

#if defined(DJ) || defined(__BORLANDC__) || defined(MSC) || defined(UNIX)
	#include <sys/stat.h>
	#include <time.h>
#else
	#include <stat.h>
	#include <time.h>
#endif

#ifdef UNIX
#define tolower(c) (('A' <= (c) && (c) <= 'Z') ? ((c) - 'A' + 'a') : (c))
#endif

#define REND
#define	ESC	'\x1B'

#include "reader.h"
#include "glib.h"
#include "rend.h"
#ifndef NO_PICLIB
#include "piclib.h"
#endif

#ifdef BG
	#include "bg.h"
#endif

/*@ϐ  */
int		antiareas = 1 ;				/*	A`GAVO			*/
int		nflag = FALSE ;				/*	摜t@Co̓IvV	*/
int		uflag = FALSE ;				/*  ʏo̓IvV			*/
int		picerrorflag = FALSE ;		/*  摜t@Co̓G[		*/
#ifdef EDGEANTI
int		EdgeAntiFlag = TRUE;
#endif
#ifdef MAPANTI
int		MapAntiFlag = FALSE;
#endif
#ifdef MOB
int		TimeAnti = 1;
#endif
#ifdef WIREVIEW
int		wiresize = 0;
#endif
int		fullcoloroutflag = FALSE;
int		fullcolorditherflag = FALSE;
#ifdef HIVISION
int		XPosition = 0, YPosition = 0;
PixelType		PixelMode = P256x256;
#endif
#ifdef BACKFACE
int		backface = FALSE;
#endif
#ifdef	XC
	int		WindowMode = FALSE ;	/*  EChE[h	*/
#endif

static	Pointer(Atr*)	atr = NULL ;			/*	Agr[gXg			*/
static	Pointer(Object*)	obj = NULL ;			/*	IuWFNgXg				*/
static	int		startframe = 1 ;		/*	X^[gt[				*/
static	int		endframe = 999 ;		/*	Ght[					*/
#ifdef NO_PICLIB
static	char	picfile[F_NAME_LEN]="" ;	/*	摜t@C					*/
static	int		picnum=0 ;				/*  摜t@C̔ԍ				*/
#else
static	PicSequence outseq;				/*	摜t@C				*/
#endif

#ifdef NO_PICLIB
static	char	backfile[F_NAME_LEN]="" ;	/*  wit@C					*/
static	int		backnum = 0 ;				/*  wit@C̔ԍ				*/
#else
static	PicSequence backseq;				/*	摜t@C				*/
#endif

#ifdef STAR
static	int		stars = 0;				/*	wi̐̐					*/
static	int		stardir = 0;			/*	wi̐̕(=0, v)	*/
static	int		starstep = 0;			/*	wi̐̑					*/
#endif
static	int		tflag = FALSE ;			/*	e|t@CgptO	*/
static	char	tempfile[F_NAME_LEN] ;	/*	e|t@C				*/
static	char	virfile[F_NAME_LEN] ;	/*  zLt@C				*/
static	char	*ext[4] =
	{ ".ATR", ".SUF", ".FRM", ".FSC" };	/*  gq							*/

#ifdef	BG
	static	int		bgmode = 4 ;		/*  obNOEh̃[h		*/
	static	struct	COMBUF	combuf ;	/*  ʐMobt@					*/
#endif
#if defined(X68000)
	static	long	dsize = 0L ;		/*	f[^̈̃TCY				*/
	static	char	**WindowArgv ;		/*  t@C					*/
	static	int		WindowArgc ;		/*	̐						*/
#elif defined(DJ) || defined(UNIX) || defined(__WIN32__)
	static	long	dsize = 16L*1024L*1024L ;/*	f[^̈̃TCY			*/
#elif defined(MSC) || defined(__BORLANDC__)
	static	long	dsize = 200L*1024L ;/*	f[^̈̃TCY				*/
#else
	static	long	dsize = 0L ;/*	f[^̈̃TCY				*/
#endif
#ifndef WINDOWS
	static	char	precommandline[256] = "";
	static	char	postcommandline[256] = "";
#endif

	static	char	logfile[F_NAME_LEN]="REND.LOG";
	static	char	logcommandline[1024]="";
	static	int		logflag=FALSE;
	FILE		*logfp = NULL;
	static	long		peakusedarea=0, peakfreearea = 256L * 1024L * 1024L;
	static	time_t	starttime, laptime1, laptime2;

#ifdef RENDXVI
	int _SSP;
#endif

/*
	proto -s rend.c > temp
*/
#ifdef WINDOWS
extern	void	check_winmessage( void );
#else
static	void	check_esc( void );
#endif
#ifdef BG
static	void	check_kill( void );
#endif
static	void	mainloop( void );
static	void	analizeargs( int, char*[] );
static	void	analizeoption( char* );
static	int		piccheck( char* );
static	void	usage( void );
static	void	error( int, char* );
static	int		isext( char* );

#ifndef WINDOWS
void commandexec(char *, int, char *, int, char *, int);
#endif
#ifdef WINDOWS
int		Main(int argc, char *argv[] )
#else
int		main(int argc, char *argv[] )
#endif
{
#ifdef RENDXVI
	_SSP = SUPER( 0 );
#endif
	fprintf(stderr, "%s%s%s", program, version, copyright);
	virtualmode = FALSE ;
#ifdef WINDOWS
	interrupt = check_winmessage ;
#else
	interrupt = check_esc ;
#endif
	(*interrupt)();
	errorexec = (void (*)(int))error ;

	analizeargs( argc, argv );

#ifdef	BG
	if ( BackGroundJob )
	{
		int		ret ;
		static  char    sspbuf[1000] ;
		extern	char	*_SEND ;

		combuf.bufsize = 0 ;
		combuf.address = NULL ;
		combuf.flag = 0xFFFF ;
		interrupt = check_kill ;

		ret = bg_set( "REND", bgmode, _SEND, sspbuf+1000,
						mainloop, &combuf, 2000 );
	    if ( ret < 0 )
    	{
			fprintf( stderr,
				"obNOEhvZXo^ł܂łB\n" );
			exit( 1 );
		}
		freopen( "nul", "w", stdout );
		freopen( "nul", "w", stderr );
		keepexit( 1, 0 );
	}
#endif
	mainloop();
#ifdef RENDXVI
	STACK_ADJUST:
	SUPER( _SSP );
#endif
	return( 0 );
}

#ifndef WINDOWS
static	void	check_esc()
{
#if (defined(VGA) || !defined(DJ)) && !defined(UNIX)
	while( kbhit() != 0 )
	{
		if ( getch() == ESC )
		{
			fprintf( stderr, "\nESC L[܂B\n" );
			fprintf( stderr, "𒆒f܂B\n\n" );
			fcloseall();
#ifdef	VIRTUAL
			if ( virtualmode )
				unlink( virfile );
#endif
			exit( 1 );
		}
	}
#endif
}
#endif

#ifdef	BG
static	void	check_kill()
{
	bg_check_kill( &combuf, "REND I܂B" );
}
#endif
static	void	mainloop()
{
	long n;
	int		fr ;	/*	t[@*/
	char	name[F_NAME_LEN] ;
	long	size ;
	Frame	*frame ;
	Pointer(void*)	mark;
	Pointer(void*) errormark ;
	FILE	*fp ;

	size = datasize();
	mark = datamark();

	for( fr = 1 ; fr < startframe ; ++fr )
	{
#ifdef STAR
		if (stars > 0) {
			StarStep();
		}
#endif
		if ( frameskip() == 0 )
			error( 1, NULL );
	}

	PictureOutput = picout ;

	if ( ! uflag )
	{
		LineOutput = piclineout ;
#ifdef HIVISION
		{
			switch (PixelMode) {
				case P256x256:		crtinit(  256 );	break;
				case P512x512:		crtinit(  512 );	break;
				case P640x400:		crtinit(  512 );	break;
				case P640x480:		crtinit(  512 );	break;
				case P1024x1024:	crtinit( 1024 );	break;
				case P1920x1125:	crtinit( 2048 );	break;
				case P2048x2048:	crtinit( 2048 );	break;
				case P4096x4096:	crtinit( 4096 );	break;
				default:
					;
			}
		}
#else
		crtinit( YPixel / antiareas );
#endif
	}

	if (logflag) {
		laptime1 = time(NULL);
	}
#ifdef NO_PICLIB
	if ( picnum == 0 )
		picnum = fr ;
#else
	if (outseq.number == 0) {
		outseq.number = fr;
	}
	PicSequence_forceAnim(&outseq);
#endif
	while( ! end_of_file && fr <= endframe )
	{
#ifndef WINDOWS
		if (precommandline[0] != '\0') {
#ifdef NO_PICLIB
			commandexec(precommandline, fr, picfile, picnum, backfile, backnum);
#else
			commandexec(precommandline, fr, outseq.body, outseq.number, backseq.body, backseq.number);
#endif
		}
#endif
		frame = frameread( obj );
		if ( frame == NULL )
			error( 1, NULL );
		errormark = datamark();
		do
		{
			if ( ! uflag )
				crtclr();
			fprintf( stderr, "Frame %d\n", fr );
#ifndef VGA
			fprintf( stderr, "   gpf[^̈  : %ld Byte\n", size );
#else
			fprintf( stderr, "   Data  : %ld Byte\n", size );
#endif
#ifdef WINDOWS
			if (logflag && logfp != NULL) {
				fprintf( logfp, "Frame %d\n", fr );
				fprintf( logfp, "   gpf[^̈  : %ld Byte\n", size );
			}
#endif
			n = ViewConv( frame );
			picerrorflag = FALSE ;
			if (logflag) {
				laptime2 = time(NULL);
			}
#ifndef VGA
			fprintf( stderr, "   gp[N̈  : %ld Byte\n", datasize() - size );
			fprintf( stderr, "   |S      : %ld\n", n );
#else
			fprintf( stderr, "   Work  : %ld Byte\n", datasize() - size );
			fprintf( stderr, "   Polys : %ld\n", n );
#endif
#ifdef WINDOWS
			if (logflag && logfp != NULL) {
				fprintf( logfp, "   gp[N̈  : %ld Byte\n",
												datasize() - size );
				fprintf( logfp, "   |S      : %ld\n", n );
			}
#endif
#ifdef NO_PICLIB
			sprintf( name, "%s%03d.PIC", picfile, picnum );
#else
			PicSequence_get(&outseq, name);
#endif
			if ( BackLoad )
			{
#ifdef NO_PICLIB
				if ( backnum == 0 )
				{
					sprintf( BackFile, "%s.PIC", backfile );
				}
				else
				{
					sprintf( BackFile, "%s%03d.PIC", backfile, backnum );
				}
#else
				PicSequence_get(&backseq, BackFile);
#endif
			}
			fp = picinit( name );
#ifdef WIREVIEW
			if (nflag || fp != NULL) {
				if (wiresize == 0) {
					Display( frame, n );
				} else {
					wiresave();
				}
			}
#else
			if (nflag || fp != NULL )
			{
				Display( frame, n );
			}
#endif
			if ( picerrorflag )
			{
				datarelease( errormark );
				if ( ! uflag )
					crtclr();
#ifdef WINDOWS
				error(0, "t@Co͂Ɏs܂" );
#endif
				fprintf( stderr, "摜t@Co͂ŃG[܂B\n" );
				fprintf( stderr, "fBXNςƎv܂B\n" );
#ifndef WINDOWS
				fprintf( stderr, "fBXNւĂB\n" );
				fprintf( stderr, "łǂꂩL[ĂB\n" );
#endif
#ifdef DJ
				fgetc(stdin);
#else
#ifdef UNIX
				fgetc(stdin);
#else
				getch() ;
#endif
#endif
			}
		}
		while( picerrorflag );

		if (logflag) {
			long freearea, usedarea;
			time_t nowtime;
			nowtime = time(NULL);
			if (logfp  != NULL) {
				fprintf(logfp, "%24s %6dkB %6dkB %6dkB %8d %5db %5db\n",
				name, size/1024, ((usedarea=datasize())-size-1)/1024+1, (freearea=memgetsize())/1024,
				n, laptime2 - laptime1, nowtime - laptime2);
				if (usedarea > peakusedarea) {
					peakusedarea = usedarea;
				}
				if (freearea < peakfreearea) {
					peakfreearea = freearea;
				}
				laptime1 = nowtime;
			}
		}

		datarelease( mark );
#ifndef WINDOWS
		if (postcommandline[0] != '\0') {
#ifdef NO_PICLIB
			commandexec(postcommandline, fr, picfile, picnum, backfile, backnum);
#else
			commandexec(postcommandline, fr, outseq.body, outseq.number, backseq.body, backseq.number);
#endif
		}
#endif
		fr ++ ;
#ifdef NO_PICLIB
		picnum ++ ;
		if ( BackLoad && backnum != 0) {
			backnum ++ ;
		}
#else
		PicSequence_next(&outseq);
		if (BackLoad) {
			PicSequence_next(&backseq);
		}
#endif
	}
	if (logflag) {
		time_t nowtime, lap;
		nowtime = time(NULL);
		lap = nowtime - starttime;
		if (logfp != NULL) {
			fprintf(logfp, "v=%d:%02d:%02d őgp̈=%8dkB ŏ󂫃̈=%8dkB\n",
					lap / 3600, (lap / 60) % 60, lap % 60,
					(peakusedarea-1)/1024+1, peakfreearea/1024);
		}
	}

#ifndef DJ
#ifndef UNIX
	fcloseall();
#endif
#endif
#ifdef	VIRTUAL
	if ( virtualmode )
		unlink( virfile );
#endif
#ifdef	BG
	if ( BackGroundJob )
		bg_kill();
#endif
}

/*	R}hC̕]	*/
static	void	analizeargs( argc, argv )
int		argc ;
char	*argv[] ;
{
	int		i, j;
	int		files[4] ;
	char	framefile[F_NAME_LEN], framesource[F_NAME_LEN], *p ;
	char	buf[256] ;
	char	*option ;
	long	fsctime ;
	struct	stat	statbuf, *sbuf = &statbuf ;

	option = getenv( "RENDLOG" );
	if ( option == NULL )
		option = getenv( "rendlog" );
	if ( option != NULL ) {
		logflag = TRUE;
		if ( option[0] == '\0' )
			strcpy( logfile, "REND.LOG" );
		else
			strcpy( logfile, option );
		i = strlen( logfile );
		if ( logfile[i-1] == '\\' || logfile[i-1] == ':' )
			strcat( logfile, "REND.LOG" );
	}
	for (i = 1; i < argc; ++i) {
#ifdef NOSLASHOPT
		if ((argv[i][0] == '-') && (argv[i][1] == 'l' || argv[i][1] == 'L')) {
#else
		if ((argv[i][0] == '-' || argv[i][0] == '/') && (argv[i][1] == 'l' || argv[i][1] == 'L')) {
#endif
			logflag = TRUE;
			break;
		}
	}
	if (logflag) {
		for (i = 0; i < argc; ++i) {
			strcat(logcommandline, " ");
			strcat(logcommandline, argv[i]);
		}
	}

	extendargs( &argc, &argv, 4, ext );
	if ( argc == 1 )
		usage() ;

#ifdef NO_PICLIB
	strcpy( picfile, "" );
	picnum = 0 ;
#else
	outseq.body[0] = '\0';
	outseq.number = 0;
	backseq.body[0] = '\0';
#endif
	for( i = 0 ; i < 4 ; ++i )
		files[i] = 0 ;

#ifdef WINDOWS
	XPixel = 320;
	YPixel = 240;
	PixelRatio = 1.0;
	PixelMode = P512x512;
#endif
	for( i = 1 ; i < argc ; ++i )
	{
#ifdef NOSLASHOPT
		if ( argv[i][0] == '-' )
#else
		if ( argv[i][0] == '-' || argv[i][0] == '/' )
#endif
		{
			analizeoption( argv[i] );
			argv[i] = "" ;
		}
	}

#ifdef	XC
	if ( WindowMode )
	{
		argv = WindowArgv - 1 ;
		argc = WindowArgc + 1 ;
	}
#endif
	for( i = 1 ; i < argc ; ++i )
	{
		if ( argv[i][0] != '\0' )
		{
			j = isext( argv[i] ) ;
			switch( j )
			{
				case -1 :
					usage();
					break ;
				case 2 :
					if ( files[3] == 0 )
					{
						strcpy( framefile, argv[i] );
						files[2] = 1 ;
					}
					break ;
				case 3 :
#ifndef WINDOWS
					files[2] = 0 ;
					files[3] = 1 ;
					strcpy( framefile, argv[i] );
#endif
					break ;
				default :
					files[j] ++ ;
					break ;
			}
		}
	}
#ifndef MESSAGE
	fprintf( stderr, "\n" );
#endif

#ifdef	BG
	if ( BackGroundJob && dsize == 0 )
		error( 0, "f[^̈̑傫w肳Ă܂B" );
#endif
#ifdef WIREVIEW
	if (wiresize > 0) {
		ShadingModel = FLAT_SHADE;
	}
#endif


	XPixel *= antiareas ;
	YPixel *= antiareas ;
	if ( YPixel > MAXLINE )
		error( 0, "𑜓x܂B" );


	if (logflag) {
		if (logfp != NULL) {
			fputs("R}hC =", logfp);
			fputs(logcommandline, logfp);
			fputs("\n          摜t@C   f[^   [N   c |S ϊ \n", logfp);
		} else {
			logflag = FALSE;
		}
		starttime = time(NULL);
	}

	/*	G[`FbN	*/
	if ( files[0] == 0 )
		error( 0, "Agr[gt@C܂B" );
	if ( files[1] == 0 )
		error( 0, "`t@C܂B" );
	if ( files[2] == 0 && files[3] == 0 )
		error( 0, "t[t@C܂B" );
#ifdef NO_PICLIB
	if ( strcmp( picfile, "" ) == 0 )
		strcpy( picfile, framefile );
	picnum = piccheck( picfile );
#else
	if (outseq.body[0] == '\0') {
		PicSequence_set(&outseq, framefile);
		strcpy(outseq.ext, "PIC");
	}
#endif

	/*	t[\[X̂Ƃ̏	*/
	if ( files[3] > 0 )
	{
		strcpy( framesource, framefile );
		p = strrchr( framefile, '.' );
		strcpy( p, ".FRM" );
		if ( stat( framesource, sbuf ) == -1 )
#ifdef JAP
			error( 0, "t[\\[Xt@C܂B" );
#else
			error( 0, "t[\[Xt@C܂B" );
#endif
		fsctime = sbuf->st_atime ;
		if ( stat( framefile, sbuf ) == -1 || fsctime > sbuf->st_atime )
		{
			option = getenv( "FFOPTION" );
			if ( option == NULL )
				option = getenv( "ffoption" );
			if ( option == NULL )
				option = "" ;
	#ifdef DJ
			sprintf( buf, "ff386 %s %s", option, framesource );
	#else
			sprintf( buf, "ff %s %s", option, framesource );
	#endif
			system( buf );
			fprintf( stderr, "\n" );
		}
	}


	/*	f[^obt@̏  */
	meminit( dsize );
#ifdef	VIRTUAL
	if ( virtualmode )
		virinit( virfile );
#endif


#ifdef STAR
	if (stars > 0) {
		StarInit(stars, stardir, starstep);
	}
#endif

	/*	Agr[gt@C̃[h	*/
	fprintf( stderr, "Reading Attribute File\n" );
#ifdef WINDOWS
	if (logflag && logfp != NULL) {
		fprintf( logfp, "Reading Attribute File\n" );
	}
#endif
	for( i = 1 ; i < argc ; ++i )
	{
		if ( isext( argv[i] ) == 0 )
		{
			fprintf( stderr, "%s\n", argv[i] );
#ifdef WINDOWS
			if (logflag && logfp != NULL) {
				fprintf( logfp, "%s\n", argv[i] );
			}
#endif
			atr = atrread( argv[i], atr ) ;
			if ( atr == NULL )
				error( 1, NULL );
			argv[i] = "" ;
		}
	}
	if ( ShadingModel == GOURAUD_SHADE )
		MapInit( atr );

	/*	`t@C̃[h	*/
	fprintf( stderr, "Reading Object File\n" );
#ifdef WINDOWS
	if (logflag && logfp != NULL) {
		fprintf( logfp, "Reading Object File\n" );
	}
#endif

	if ( tflag )
		tempopen( tempfile );
	for( i = 1 ; i < argc ; ++i )
	{
		if ( isext( argv[i] ) == 1 )
		{
			fprintf( stderr, "%s\n", argv[i] );
#ifdef WINDOWS
			if (logflag && logfp != NULL) {
				fprintf( logfp, "%s\n", argv[i] );
			}
#endif
			if ( tflag )
				obj = tempread( argv[i], obj );
			else
				obj = objread( argv[i], obj );
			if ( obj == NULL )
				error( 1, NULL );
			argv[i] = "" ;
		}
	}
	if ( tflag )
		tempclose( tempfile );
	if ( objatr( obj, atr ) == FALSE )
		exit( 1 );

	/*	t[t@C̃I[v	*/
	fprintf( stderr, "Reading Frame File\n" );
	fprintf( stderr, "%s\n", framefile );
#ifdef WINDOWS
	if (logflag && logfp != NULL) {
		fprintf( logfp, "Reading Frame File\n" );
		fprintf( logfp, "%s\n", framefile );
	}
#endif

	if ( frameopen( framefile ) == 0 )
		error( 1, NULL );
}

/*	IvV̕]At@C̃`FbN	*/
static	void	analizeoption( str )
char	*str ;
{
	int		i, n ;
	char	*p ;
#ifdef	BG
	struct	PROCESS	processbuf ;
#endif

	switch( tolower( str[1] ) )
	{
		case 'a' :
#ifdef MAPANTI
			if (tolower(str[2]) == 'm') {
				MapAntiFlag = TRUE;
				fprintf(stderr, "}bsOɃA`GCAVO܂B\n");
				break;
			}
#endif
#ifdef MOB
			if (tolower(str[2]) == 't') {
				n = atoi(str+3);
				if (n != 2 && n != 4) {
					error( 0, "IvV'AT'̎w̌" );
				}
				fprintf( stderr,
					"ԕ %d {𑜓xŃA`GAVO܂B\n", n );
				TimeAnti = n;
				break;
			}
#endif
			n = atoi( str+2 );
			if ( n <= 1 || 9 <= n )
			error( 0, "IvV'A' 2 ` 9 Ɏ܂Ă܂" );
			fprintf( stderr,
				" %d {𑜓xŃA`GAVO܂B\n", n );
			antiareas = n ;
			break ;
		case 'b' :
#ifdef BGMAKE
			if (str[2] == '\0') {
#endif
			fprintf( stderr, "obN𓧖ɂ܂B\n" );
			TraBack = 1 ;
#ifdef BGMAKE
			} else {
				BgMake = 0;
				p = str+2;
                i = 0;
				for (;*p;p++) {
					if (*p == ',' || (i > 2 && *p == ':')) {
						BgMakeFile[BgMake][i] = '\0';
						i = 0;
						BgMake++;
						if (BgMake == 12) {
							error( 0, "IvV'B'摜" );
						}
					} else {
						BgMakeFile[BgMake][i++] = *p;
					}
				}
				BgMakeFile[BgMake][i] = '\0';
				BgMake++;
				if (BgMake == 1) {
					fprintf( stderr, "wiAɍWn: %s ōs܂B\n",BgMakeFile[0]);
				} else if (BgMake == 2) {
					fprintf( stderr, "wiAO: %sAE: %s ōs܂B\n",
							BgMakeFile[0], BgMakeFile[1]);
				} else if (BgMake == 4) {
					fprintf( stderr, "wiAO: %sAE: %s : %s : %s ōs܂B\n",
							BgMakeFile[0], BgMakeFile[1],
							BgMakeFile[2], BgMakeFile[3]);
				} else if (BgMake == 6) {
					fprintf( stderr, "wiAO: %sA㍶E: %s O: %s E: %s O: %s E: %s ōs܂B\n",
							BgMakeFile[0], BgMakeFile[1],
							BgMakeFile[2], BgMakeFile[3],
							BgMakeFile[4], BgMakeFile[5]);
				} else if (BgMake == 12) {
					fprintf( stderr,
						"wiA\n"
						"\t: %s, %s, %s, %s\n"
						"\t: %s, %s, %s, %s\n"
						"\t: %s, %s, %s, %s\n"
						"\t\tōs܂B\n",
						BgMakeFile[0], BgMakeFile[1],BgMakeFile[2],BgMakeFile[3],
						BgMakeFile[4], BgMakeFile[5],BgMakeFile[6],BgMakeFile[7],
						BgMakeFile[8], BgMakeFile[9],BgMakeFile[10],BgMakeFile[11]);
				} else {
					error( 0, "IvV'B' 摜̖" );
				}
			}
#endif
			break ;
		case 'c' :
#ifdef HIVISION
			{
				int nx = 0, ny = 0;
				int rx = 0, ry = 0;
				int cc;
				nx = atoi( str+2 ) ;
				for (cc = 2; str[cc]; ++cc) {
					if (str[cc] == 'X' || str[cc] == 'x' || str[cc] == '*'
					 || str[cc] == ',' || str[cc] == ':') {
						ny = atoi(str+cc+1);
						break;
					}
				}
				if (ny != 0) {
					for (cc++; str[cc]; ++cc) {
						if (str[cc] == ',' || str[cc] == ':') {
							rx = atoi(str+cc+1);
							break;
						}
					}
				}
				if (rx != 0) {
					for (cc++; str[cc]; ++cc) {
						if (str[cc] == ',' || str[cc] == ':') {
							ry = atoi(str+cc+1);
							break;
						}
					}
				}
				if (ny == 0) {
					ny = nx;
				}
				XPixel = nx;
				YPixel = ny;
				if (nx == 320 && ny == 200) {
					PixelMode = P320x200;
					PixelRatio = 1.00;
				} else if (nx == 320 && ny == 240) {
					PixelMode = P512x512;
					PixelRatio = 1.00;
				} else if (nx == 640 && ny == 400) {
					PixelMode = P640x400;
					PixelRatio = 1.00;
				} else if (nx == 640 && ny == 480) {
					PixelMode = P640x480;
					PixelRatio = 1.00;
				} else if (nx == 1920 && ny == 1125) {
					PixelMode = P1920x1125;
					PixelRatio = 1.00;
				} else if (2 <= nx && nx <= 512 && 2 <= ny && ny <= 512) {
					if (XPixel >  256 || YPixel > 256) {
						PixelMode = P512x512;
					} else {
						PixelMode = P256x256;
					}
/*					PixelRatio = 0.75;*/
					PixelRatio = (Float)XPixel / (Float)YPixel * 0.75;
				} else if (nx <= 1024 && ny <= 1024) {
					PixelMode = P1024x1024;
					PixelRatio = 0.75;
				} else if (nx <= 2048 && ny <= 2048) {
					PixelMode = P2048x2048;
					PixelRatio = (Float)XPixel / (Float)YPixel * 0.75;
				} else if (nx <= 4096 && ny <= 4096) {
					PixelMode = P4096x4096;
					PixelRatio = (Float)XPixel / (Float)YPixel * 0.75;
				} else {
					error( 0, "IvV'C' 𑜓x" );
				}
				if (rx != 0 && ry != 0) {
					PixelRatio = (Float)XPixel / (Float)YPixel * (Float)ry / (Float)rx;
				}
			}
#else
			n = atoi( str+2 ) ;
			if ( n == 256 || n == 512 )
				XPixel = YPixel = n ;
			else
				error( 0, "IvV'C'̎w̌" );
#endif
			fprintf( stderr, "ʃTCY %d * %d łB\n", XPixel, YPixel );
			break ;
		case 'd' :
			n = atoi(str+2);
			if (tolower(str[2]) == 'r') {
				fprintf( stderr, "_fBUč悵܂B\n");
				fullcoloroutflag = FALSE;
				fullcolorditherflag = RANDOMDITHER;
			} else if (tolower(str[2]) == 'e' && str[3] == '2') {
				fprintf( stderr, "덷gU256Fō悵܂B\n");
				fullcoloroutflag = FALSE;
				fullcolorditherflag = ERRORDIFUSION2;
			} else if (tolower(str[2]) == 'e') {
				fprintf( stderr, "덷gUō悵܂B\n");
				fullcoloroutflag = FALSE;
				fullcolorditherflag = ERRORDIFUSION;
			} else if (n==0 || n == 200 || n == 400 || tolower(str[2]) == 'd'|| n == 2) {
				fprintf( stderr, "fBUċ^200Fō悵܂B\n");
				fullcoloroutflag = FALSE;
				fullcolorditherflag = ORDEREDDITHER4;
			} else if (tolower(str[2]) == 'o' || n == 4) {
				fprintf( stderr, "fBUċ^1400Fō悵܂B\n");
				fullcoloroutflag = FALSE;
				fullcolorditherflag = ORDEREDDITHER8;
			} else if (tolower(str[2]) == 'f'
				 || tolower(str[2]) == 't' || n == 1600) {
				fprintf( stderr, "16,777,216FtJ[ō悵܂B\n");
				fullcoloroutflag = TRUE;
				fullcolorditherflag = ORDEREDDITHER4;
			} else {
				error( 0, "IvV'D' r, e, o, t̂ǂꂩ" );
			}
			break;
#ifndef WINDOWS
		case 'e' :
				if (str[2] == '0' || tolower(str[2]) == 's' || tolower(str[2]) == 'b') {
					strcpy(precommandline, str+3);
					fprintf( stderr, "et[撼OɃR}h'%s's܂B\n", str+3);
					if (tolower(precommandline[0]) == 'd' &&
						tolower(precommandline[1]) == 'e' &&
						tolower(precommandline[2]) == 'l' &&
						isspace(precommandline[3])) {
					} else {
						dsize = (long)-512*1024;
					}
				} else if (str[2] == '1' || tolower(str[2]) == 'e') {
					strcpy(postcommandline, str+3);
					fprintf( stderr, "et[撼ɃR}h'%s's܂B\n", str+3);
					if (tolower(precommandline[0]) == 'd' &&
						tolower(precommandline[1]) == 'e' &&
						tolower(precommandline[2]) == 'l' &&
						isspace(precommandline[3])) {
					} else {
						dsize = (long)-512*1024;
					}
				}
			break;
#endif
		case 'f' :
			FrontClip = atof( str+2 );
			if ( FrontClip <= 0.0 )
				error( 0, "OʃNbsOB" );
			fprintf( stderr,
				"OʃNbsO %g ɂ܂B\n", FrontClip );
			break ;
		case 'g' :
			ShadingModel = GOURAUD_SHADE ;
			fprintf( stderr, "X[YVF[fBO܂B\n" );
			break ;
		case 'h' :
				BackLoad = TRUE ;
#ifdef NO_PICLIB
				strcpy( backfile, str+2 );
				fprintf( stderr, "wit@C %s ǂݍ݂܂B\n", backfile );
				backnum = piccheck( backfile );
#else
				PicSequence_set(&backseq, str+2);
				fprintf( stderr, "wit@C %s ǂݍ݂܂B\n", str+2 );
#endif
			break ;
#ifdef STAR
		case 'i' :
			{
				int cc, dir = 0, step = 0;
				n = atoi(str+2);
				for (cc = 2; str[cc]; ++cc) {
					if (str[cc] == 'X' || str[cc] == 'x' || str[cc] == '*'
					 || str[cc] == ',' || str[cc] == ':') {
						dir = atoi(str+cc+1);
						break;
					}
				}
				if (isdigit(str[cc+1]) || str[cc+1] == '-') {
					for (cc++; str[cc]; ++cc) {
						if (str[cc] == ',' || str[cc] == ':') {
							step = atoi(str+cc+1);
							break;
						}
					}
				}
				if (n == 0) {
					n = 1000;
				}
				if (-180 <= dir && dir <= 360 && 0 < step && step <= 360) {
					fprintf( stderr, "wi %d xɑ %d xŐi %d ̐`܂B\n", dir, step, n );
					stardir = dir;
					starstep = step;
				} else {
					fprintf( stderr, "wi %d ̐`܂B\n", n );
				}
				stars = n;
			}
			break;
#endif
#ifdef	BG
		case 'j' :
			BackGroundJob = TRUE ;
			n = atoi( str+2 );
			if ( 0 < n && n < 256 )
				bgmode = n ;
			fprintf( stderr, "obNOEhWuŎs܂B\n" );
			break ;
#endif
#ifdef EDGEANTI
		case 'k' :
			EdgeAntiFlag = FALSE;
			fprintf( stderr, "GbWɃA`GCAVO܂B\n" );
			break;
#endif
		case 'l' :
			logflag = TRUE;
			if ( str[2] == '\0' )
				strcpy( logfile, "REND.LOG" );
			else
				strcpy( logfile, str+2 );
			i = strlen( logfile );
			if ( logfile[i-1] == '\\' || logfile[i-1] == ':' )
				strcat( logfile, "REND.LOG" );
			fprintf( stderr, "惍O %s ɏ݂܂B\n", logfile );
			logfp = fopen(logfile, "a");
#ifdef WINDOWS
			errfp = logfp;
#endif
			break ;
		case 'm' :
			n = atoi( str+2 );
			if ( n < -1000 || 16000 < n )
				error( 0, "IvV'M' w̌" );
			fprintf( stderr, "f[^̈ %d Kbyte mۂ܂B\n", n );
			dsize = (long)n * 1024L ;
			break ;
		case 'n' :
			fprintf( stderr, "摜t@Co͂܂B\n" );
			nflag = 1 ;
			break ;
		case 'o' :
#ifdef NO_PICLIB
			strcpy( picfile, str+2 );
#else
			PicSequence_set(&outseq, str+2);
#endif
			fprintf( stderr, "摜t@C %s ɂ܂B\n", str+2 );
			break ;
#ifdef HIVISION
		case 'p' :
			{
				int nx, ny = 0;
				int cc;
				nx = atoi( str+2 ) ;
				for (cc = 2; str[cc]; ++cc) {
					if (str[cc] == 'X' || str[cc] == 'x' || str[cc] == '*'
					 || str[cc] == ',' || str[cc] == ':') {
						ny = atoi(str+cc+1);
						break;
					}
				}
				XPosition = nx;
				YPosition = ny;
				if (nx < 0 || nx >= 512 || ny < 0 || ny >= 512) {
					error( 0, "IvV'P' ̎w̌" );
				}
			}
			break;
#endif
#ifdef	BACKFACE
		case 'q':
			backface = TRUE;
			fprintf(stderr, "ʂ͍悵܂B\n");
			break;
#endif
#ifdef	BG
		case 'r':
			strcpy( processbuf.name, "REND" );
			n = bg_get( -1, &processbuf );
			if ( n > 0 )
    		{
    			if ( bg_send( 0, n, 0xFFF9, NULL, 0 ) < 0 )
					fprintf( stderr, " G[܂B\n" );
			}
			else
    			fprintf( stderr, " REND ݂܂B\n" );
			exit( 0 );
#endif
#ifdef REFMAP
		case 'r' :
			RefMap = 1;
			strcpy(RefMapFile[0], str+2);
			while ((p = strchr(RefMapFile[RefMap-1], ',')) != NULL
			    || (p = strchr(RefMapFile[RefMap-1]+2, ':')) != NULL) {
				*p = '\0';
				if (RefMap == 6) {
					error( 0, "IvV'R' 摜̖" );
				}
				strcpy(RefMapFile[RefMap++], p+1);
			}
			if (RefMap == 1) {
				fprintf( stderr, "}bsOAɍWn: %s ōs܂B\n",RefMapFile[0]);
			} else if (RefMap == 2) {
				fprintf( stderr, "}bsOA㔼: %sA: %s ōs܂B\n",
						RefMapFile[0], RefMapFile[1]);
			} else if (RefMap == 6) {
				fprintf( stderr,
					"}bsOAO: %sAE: %s : %s : %s : %s : %s ōs܂B\n",
					RefMapFile[0], RefMapFile[1],RefMapFile[2],
					RefMapFile[3], RefMapFile[4],RefMapFile[5]);
			} else {
				error( 0, "IvV'R' 摜̖" );
			}
			break;
#endif
		case 's' :
			p = strchr( str+2, ':' );
			if ( p != NULL )
				*p = '\0' ;
			/*	X^[gt[̃`FbN	*/
			startframe = atoi( str+2 );
			if ( startframe <= 0 )
				startframe = 1 ;
			else
			{
				fprintf( stderr, " %d t[`n߂܂B\n",
					startframe );
			}
			/*	Ght[̃`FbN  */
			if ( p != NULL )
			{
				/*	Ght[  */
				endframe = atoi( p+1 );
				if ( startframe > endframe )
					error( 0, "IvV'S' Jnt[It[̕" );
				fprintf( stderr, " %d t[ŏI܂B\n", endframe );
			}
			break ;
		case 't' :
			tflag = TRUE ;
			if ( str[2] == '\0' )
				strcpy( tempfile, "REND.TMP" );
			else
				strcpy( tempfile, str+2 );
			i = strlen( tempfile );
			if ( tempfile[i-1] == '\\' || tempfile[i-1] == ':' )
				strcat( tempfile, "REND.TMP" );
			fprintf( stderr, "e|t@C %s gp܂B\n",
					tempfile );
			break ;
		case 'u' :
			uflag = TRUE ;
			fprintf( stderr, "ʏo͂܂B\n" );
			break ;
		case 'v' :
			virtualmode = TRUE ;
			if ( str[2] == '\0' )
				strcpy( virfile, "REND.SWP" );
			else
				strcpy( virfile, str+2 );
			i = strlen( virfile );
			if ( virfile[i-1] == '\\' || virfile[i-1] == ':' )
				strcat( virfile, "REND.SWP" );
			fprintf( stderr,
				"zLt@C %s gp܂B\n", virfile );
			break ;
#ifdef WIREVIEW
		case 'w' :
			n = atoi( str+2 );
			if ( n <= 1 || 5 <= n ) {
				n = 1;
			}
			fprintf( stderr,"o͉摜C[t[ɂ܂B\n", n );
			wiresize = n ;
			break ;
#endif
#ifdef	XC
		case 'w' :
			WindowMode = TRUE ;
			WindowArgv = atoi( str+2 );
			for( WindowArgc = 0 ; WindowArgv[WindowArgc] != NULL ; ++ WindowArgc );
			fprintf( stderr, "EChE[hŎs܂B\n" );
			break ;
#endif
		case '?' :
			usage() ;
			break ;
		default :
			error( 0, "s̃IvVw" );
	}
}

#ifdef NO_PICLIB
/*	摜t@C̃`FbN  */
static	int		piccheck( name )
char	*name ;
{
	char	*p, *p2 ;
	int		i, n, ret ;
#if 0
	if ( *name == '.' )
		p = name + 2 ;	/*	efBNg  */
	else
		p = name ;
#else
	if (p2 = strrchr(name, ':'), p2++ == NULL) {
		p2 = name;
	}
	if (p = strrchr(p2, '\\'), p++ == NULL) {
		p = p2;
	}
#endif
	p = strchr( p, '.' ) ;
	if ( p != NULL )	/*	gq폜  */
		*p = '\0' ;

	ret = 0 ;
	n = strlen( name );
	if ( isdigit( name[n-3] ) && isdigit( name[n-2] ) && isdigit( name[n-1] ) )
	{
		ret = atoi( name + n - 3 );
		name[n-3] = '\0' ;
	}

	p = name + strlen( name ) - 1 ;
	for( i = 0 ; *p != '\\' && *p != ':' && p >= name ; ++i )
		--p ;
	if ( ret != 0 && i > 5 )
		error( 0, "摜t@C܂B" );

	return( ret );
}
#endif

/*	usage ̕\	*/
static	void	usage()
{
	int		i ;

	static	char	*msg[] = {
			"gp@Frend [ -Options ] [#<IndirectFile>] < File... ( .atr .suf .frm ) >",
			"Option  -a<num>           : <num>{𑜓xŃA`GAVO",
#ifdef MAPANTI
			"        -am               : }bsOɃA`GAVO",
#endif
#ifdef MOB
			"        -at<num>          : ԕɃA`GCAVO(<num>=2,3,4)",
#endif
			"        -b                : wi𓧖ɂ",
#ifdef BGMAKE
			"        -b<file1>,<file2>,...",
			"                          : wi`",
#endif
#ifdef HIVISION
			"        -c<numx>[:<numy>] : ʃTCY<numx>~<numy>ɂ",
#else
			"        -c<num>           : ʃTCY",
#endif
/*			"        -d<num>           : <num>Fō悷(<num>=6,400,1600)",*/
			"        -d[<mode>]        : fBUO(<mode>=2,4,r,e)",
#ifndef WINDOWS
			"        -e0<command>      : R}hs(O)",
			"        -e1<command>      : R}hs()",
#endif
			"        -f<num>           : OʃNbsO",
			"        -g                : X[XVF[fBO[h",
			"        -h<filename>      : wit@Cǂݍ",
#ifdef STAR
/*			"        -i<num>           : wi<num>̐`",*/
			"        -i<num>[:<d>:<s>] : wi<num>̐<d>x̕ő<s>xŕ`",
#endif
#ifdef	BG
			"        -j[mode]          : obNOEhWuŎs",
			"                          :       ( Human68k ver 2.00 ȏ )",
#endif
#ifdef EDGEANTI
			"        -k                : GbWɃA`GCAVOȂ",
#endif
#if 0
			"        -l<filename>      : OL^",
#endif
			"        -m<num>           : f[^̈̃TCYw肷(Kbyte)",
			"        -n                : 摜t@Co͂Ȃ",
			"        -o<name>          : 摜t@C",
#ifdef HIVISION
			"        -p<numx>:<numy>   : 摜̍W(<numx>,<numy>)ɂ",
#endif
#ifdef BACKFACE
			"        -q                : ʂ`܂",
#endif
#ifdef	BG
			"        -r                : obNOEhWu𒆒fB",
#endif
#ifdef REFMAP
			"        -r<file1>,...     : }bsOsB",
			"                            t@C1: ɍWn",
			"                            t@C2: 㔼A",
			"                            t@C6: OAEAAAA",
#endif
			"        -s<num1>[:<num2>] : num1 X^[gt[",
#ifdef JAP
			"                            num2 Ght[iȗ\\j",
#else
			"                            num2 Ght[iȗ\j",
#endif
#ifndef DJ
			"        -t[filename]      : e|t@Cgp",
#endif
			"        -u                : ʏo͂Ȃ",
#ifdef	VIRTUAL
			"        -v[filename]      : zL[h",
#ifdef	EMS
			"        -vEMS             : EMSɂ鉼zL[h",
#endif
#endif
#ifdef WIREVIEW
			"        -w                : C[t[o",
#endif
#ifdef JAP
			"        -?                : gp@\\",
#else
			"        -?                : gp@\",
#endif
			"#<C_CNgt@C> ́Ãt@C̒g(s͋󔒂Ƃ)ɏ̂ƓłB",
			"ESC L[Œ~",
			""
	} ;

	for( i = 0 ; strcmp( msg[i], "" ) != 0 ; ++i )
		fprintf( stdout, "%s\n", msg[i] );
/*	putc( '\n', stderr );*/
	exit( 1 );
}

/*	G[	*/
static	void	error( n, msg )
int		n ;
char	*msg ;
{
#ifdef MESSAGE
	extern int printwarning(const char *format, ...);
#endif
	if ( n == 0 ) {
		fprintf( stderr, "R}hCG[F%s\n", msg );
#ifdef MESSAGE
		printwarning("R}hCG[F%s", msg);
#endif
	}
#ifdef MESSAGE
	else printwarning("G[܂B");
#endif
	fprintf( stderr, "G[܂B\n\n" );

#ifndef DJ
#ifndef UNIX
	fcloseall();
#endif
#endif
	exit( 1 );
}

/*
	gq̎ނԂB
		߂l	-1 : G[
				 0 : .atr
				 1 : .suf
				 2 : .frm
				 3 : .fsc
*/
static	int		isext( file )
char	*file ;
{
	int		i ;
	char	*p ;

	p = strrchr( file, '.' );
	if ( p == NULL )
		return( -1 );

	for( i = 0 ; i < 4 ; ++i )
	{
		if ( strcmpi( p, ext[i] ) == 0 )
			return( i );
	}
	return( -1 );
}
